/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

action set_note_duration(doc *d, int line, int chord, int note,
                         note_duration t)
{
  data {
    int line;
    int chord;
    int note;
    note_duration old_value;
    note_duration new_value;
  }

  do {
    data->line = line;
    data->chord = chord;
    data->note = note;
    switch (NOTE_TYPE(d, line, chord, note)) {
      case NOTE:
        data->old_value = NOTE_DURATION(d, line, chord, note);
        break;
      case SILENCE:
        data->old_value = SILENCE_DURATION(d, line, chord, note);
        break;
    }
    data->new_value = t;

    if (!doc_set_note_duration(d, line, chord, note, t)) return 0;

    if (REGISTER_HISTORY < 0) {
      doc_set_note_duration(d, line, chord, note, data->old_value);
      return -1;
    }

    d->state = STATE_MODIFIED;
    size_change_chord(d, data->line, data->chord);

    return 1;
  }

  undo {
    doc_set_note_duration(d, data->line, data->chord, data->note,
                          data->old_value);
    d->cursor.line = data->line;
    d->cursor.chord = data->chord;
    size_change_chord(d, data->line, data->chord);
    d->state = STATE_MODIFIED;
  }

  redo {
    doc_set_note_duration(d, data->line, data->chord, data->note,
                          data->new_value);
    d->cursor.line = data->line;
    d->cursor.chord = data->chord;
    size_change_chord(d, data->line, data->chord);
    d->state = STATE_MODIFIED;
  }

  save {
  }

  load {
  }

  erase {
  }
}
