/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

#ifndef _CURSOR_H_
#define _CURSOR_H_

typedef enum {
  SMALL_CURSOR, BIG_CURSOR
} cursor_type;

typedef struct {
  /* accessed by the application to set the cursor */
  void *doc;
  int type;
  int line;
  int chord;
  int note;
  /* data to blink the cursor */
  int state;	/* 0: off, 1: on */
  unsigned int timeout_id;
  int hidden_level;
} cursor;

void reset_cursor(cursor *);
void close_cursor(cursor *);
void disable_cursor(cursor *);
void enable_cursor(cursor *);

void position_cursor(cursor *, int, int);

#endif /* _CURSOR_H_ */
