/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

#ifndef _ERROR_H_
#define _ERROR_H_

typedef enum {
  FILE_OPEN_ERROR,
  FILE_CLOSE_ERROR,
  FILE_WRITE_ERROR,
  FILE_READ_ERROR,
  FILE_LOAD_ERROR
} file_error_type;

/* error codes */
enum error {
  NO_ERROR,	/* (void) */			/* no error */
  OOM,		/* (void) */			/* out of memory */
  STATE_POP,	/* (void) */			/* no state to pop */
                                                /*   on thread's stack */
  OSS_ERROR,	/* (void) */			/* error with OSS audio */
  FILE_ERROR,   /* (file_error_type, */		/* error when accessing */
                /*  char *file_name, */		/*   a file */
                /*  int errno)       */
  FATAL,	/* (void) */			/* fatal error (it should */
						/*   not happen) */
  MIDI_ERROR	/* (char *) */			/* error with midi device */
};

void set_error(enum error, ...);
const char *get_error(void);

#endif /* _ERROR_H_ */
