/* take the help.txt file and produce help_gui.h */
/* could be done in sed or anything else I guess... */
/* public domain stuff */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

int size;
int maxsize;
char *buf;

void put_char(int c)
{
  if (size == maxsize) {
    buf = realloc(buf, maxsize += 1024);
    if (!buf) exit(1);
  }
  buf[size++] = c;
}

void ultra_low_handle(char *type, char *s, int bold)
{
  if (bold) {
    printf("  gtk_wrapper_insert_two(buffer, iter,\n");
    printf("    \"%s\",\n", s);
    printf("    -1, \"%s\", \"b\");\n", type);
  }
  else {
    printf("  gtk_wrapper_insert_one(buffer, iter,\n");
    printf("    \"%s\",\n", s);
    printf("    -1, \"%s\");\n", type);
  }
}

void low_handle(char *type, char *s, int bold)
{
  int len;

  /* we split long strings, for the compiler to feel cool */
  while ((len=strlen(s)) > 70) {
    /* take care of \n, we don't want to cut it */
    int pos = 70;
    int c;
    if (s[pos] == 'n' && s[pos-1] == '\\') pos--;
    c = s[pos];
    s[pos] = 0;
    ultra_low_handle(type, s, bold);
    s[pos] = c;
    s += pos;
  }

  ultra_low_handle(type, s, bold);
}

void handle_it(char *type, char *s, int bold)
{
  char *sep;

#if 0
  while (s[0] && (s[0] == ' ' || s[0] == '\n')) s++;
  if (!s[0]) return;
#endif

  while (1) {
    sep = strstr(s, ".b ");
    if (!sep)
      return low_handle(type, s, bold);

    *sep = 0;
    low_handle(type, s, bold);

    s = sep + 3;
    bold = 1 - bold;
  }
}

void handle_line(void)
{
  if (!size) return;
  while (size && (buf[size-1] == ' ' || buf[size-1] == '\n')) size--;
  if (!size) return;
  put_char('\\');
  put_char('n');
  put_char(0);

  if (!strncmp(buf, ".p ", 3)) {
    size -= 3;
    return handle_it("p", buf+3, 0);
  }
  if (!strncmp(buf, ".h1 ", 4)) {
    size -= 4;
    return handle_it("h1", buf+4, 0);
  }
  if (!strncmp(buf, ".h2 ", 4)) {
    size -= 4;
    return handle_it("h2", buf+4, 0);
  }
  if (!strncmp(buf, ".h3 ", 4)) {
    size -= 4;
    return handle_it("h3", buf+4, 0);
  }
  handle_it("p", buf, 0);
}

int main(void)
{
  int last_eol = 0;
  int last_space = 0;

  while (1) {
    int c = getchar();
    if (c == -1) break;
    if (c == '.' && last_eol) {
      handle_line();
      size = 0;
    }
    if (!((c == '\n' || c == ' ') && last_space == 1)) {
      int d = c;
      if (d == '\\') put_char('\\');
      if (d == '\"') put_char('\\');
      if (d == '\n') d = ' ';
      put_char(d);
    }
    if (c == '\n') last_eol = 1;
    else last_eol = 0;
#if 0
    if (c == '\n' || c == ' ') last_space = 1;
    else last_space = 0;
#endif
  }

  if (size)
    handle_line();

  return 0;
}
