/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

/*
  xbm format:
  char toto[] = { 0xab, 0x... };
  1st pixel = 1st bit of byte
  if width % 8 != 0 ignore remaining bits of last byte of row
 */

#include "images.h"
#include "dprintf.h"

#include "images/becarre_x1.xbm"
#include "images/bemol_x1.xbm"
#include "images/black_head_x1.xbm"
#include "images/diese_x1.xbm"
#include "images/dot_x1.xbm"
#include "images/down_croche_x1.xbm"
#include "images/down_dcroche_x1.xbm"
#include "images/down_ddcroche_x1.xbm"
#include "images/down_dddcroche_x1.xbm"
#include "images/down_ddddcroche_x1.xbm"
#include "images/silence_blanche_x1.xbm"
#include "images/silence_croche_x1.xbm"
#include "images/silence_dcroche_x1.xbm"
#include "images/silence_ddcroche_x1.xbm"
#include "images/silence_dddcroche_x1.xbm"
#include "images/silence_ddddcroche_x1.xbm"
#include "images/silence_noire_x1.xbm"
#include "images/silence_ronde_x1.xbm"
#include "images/up_croche_x1.xbm"
#include "images/up_dcroche_x1.xbm"
#include "images/up_ddcroche_x1.xbm"
#include "images/up_dddcroche_x1.xbm"
#include "images/up_ddddcroche_x1.xbm"
#include "images/white_head_x1.xbm"
#include "images/clef_c_x1.xbm"
#include "images/clef_f_x1.xbm"
#include "images/clef_g_x1.xbm"
#include "images/clef_g_8va_x1.xbm"
#include "images/clef_g_8vb_x1.xbm"

#include "images/becarre_x2.xbm"
#include "images/bemol_x2.xbm"
#include "images/black_head_x2.xbm"
#include "images/diese_x2.xbm"
#include "images/dot_x2.xbm"
#include "images/down_croche_x2.xbm"
#include "images/down_dcroche_x2.xbm"
#include "images/down_ddcroche_x2.xbm"
#include "images/down_dddcroche_x2.xbm"
#include "images/down_ddddcroche_x2.xbm"
#include "images/silence_blanche_x2.xbm"
#include "images/silence_croche_x2.xbm"
#include "images/silence_dcroche_x2.xbm"
#include "images/silence_ddcroche_x2.xbm"
#include "images/silence_dddcroche_x2.xbm"
#include "images/silence_ddddcroche_x2.xbm"
#include "images/silence_noire_x2.xbm"
#include "images/silence_ronde_x2.xbm"
#include "images/up_croche_x2.xbm"
#include "images/up_dcroche_x2.xbm"
#include "images/up_ddcroche_x2.xbm"
#include "images/up_dddcroche_x2.xbm"
#include "images/up_ddddcroche_x2.xbm"
#include "images/white_head_x2.xbm"
#include "images/clef_c_x2.xbm"
#include "images/clef_f_x2.xbm"
#include "images/clef_g_x2.xbm"
#include "images/clef_g_8va_x2.xbm"
#include "images/clef_g_8vb_x2.xbm"

#include "images/becarre_x3.xbm"
#include "images/bemol_x3.xbm"
#include "images/black_head_x3.xbm"
#include "images/diese_x3.xbm"
#include "images/dot_x3.xbm"
#include "images/down_croche_x3.xbm"
#include "images/down_dcroche_x3.xbm"
#include "images/down_ddcroche_x3.xbm"
#include "images/down_dddcroche_x3.xbm"
#include "images/down_ddddcroche_x3.xbm"
#include "images/silence_blanche_x3.xbm"
#include "images/silence_croche_x3.xbm"
#include "images/silence_dcroche_x3.xbm"
#include "images/silence_ddcroche_x3.xbm"
#include "images/silence_dddcroche_x3.xbm"
#include "images/silence_ddddcroche_x3.xbm"
#include "images/silence_noire_x3.xbm"
#include "images/silence_ronde_x3.xbm"
#include "images/up_croche_x3.xbm"
#include "images/up_dcroche_x3.xbm"
#include "images/up_ddcroche_x3.xbm"
#include "images/up_dddcroche_x3.xbm"
#include "images/up_ddddcroche_x3.xbm"
#include "images/white_head_x3.xbm"
#include "images/clef_c_x3.xbm"
#include "images/clef_f_x3.xbm"
#include "images/clef_g_x3.xbm"
#include "images/clef_g_8va_x3.xbm"
#include "images/clef_g_8vb_x3.xbm"

#include "images/becarre_x4.xbm"
#include "images/bemol_x4.xbm"
#include "images/black_head_x4.xbm"
#include "images/diese_x4.xbm"
#include "images/dot_x4.xbm"
#include "images/down_croche_x4.xbm"
#include "images/down_dcroche_x4.xbm"
#include "images/down_ddcroche_x4.xbm"
#include "images/down_dddcroche_x4.xbm"
#include "images/down_ddddcroche_x4.xbm"
#include "images/silence_blanche_x4.xbm"
#include "images/silence_croche_x4.xbm"
#include "images/silence_dcroche_x4.xbm"
#include "images/silence_ddcroche_x4.xbm"
#include "images/silence_dddcroche_x4.xbm"
#include "images/silence_ddddcroche_x4.xbm"
#include "images/silence_noire_x4.xbm"
#include "images/silence_ronde_x4.xbm"
#include "images/up_croche_x4.xbm"
#include "images/up_dcroche_x4.xbm"
#include "images/up_ddcroche_x4.xbm"
#include "images/up_dddcroche_x4.xbm"
#include "images/up_ddddcroche_x4.xbm"
#include "images/white_head_x4.xbm"
#include "images/clef_c_x4.xbm"
#include "images/clef_f_x4.xbm"
#include "images/clef_g_x4.xbm"
#include "images/clef_g_8va_x4.xbm"
#include "images/clef_g_8vb_x4.xbm"

#include "gtk_wrapper.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

image images[NB_IMAGES];

//void gtk_wrapper_draw_image(void*e,enum image_type d, int c, int b, int a){}
static void process(enum image_type type, char *data, char *name, int zoom,
                    int width, int height)
{
  extern void *stipples[4][NB_IMAGES];
  extern int stipples_width[4][NB_IMAGES];
  extern int stipples_height[4][NB_IMAGES];
#if 0
  char col[64];
  char *q;
  int line;
#endif

  dprintf("processing %d %s\n", type, name);

  if (zoom == 1) {
    images[type].width = width;
    images[type].height = height;
  }

  stipples_width[zoom-1][type] = width;
  stipples_height[zoom-1][type] = height;
  stipples[zoom-1][type] = gtk_wrapper_create_bitmap(data, width, height);

#if 0
  pixmaps_black[zoom-1][type] = gdk_pixmap_create_from_xpm_d(
      gdk_get_default_root_window(), NULL, NULL, data);
  if (!pixmaps_black[zoom-1][type]) {
    printf("error with %s\n", name);
    exit(1);
  }
  /* ultra hardcore way to find where the black color is stored */
  if (strstr(data[2], "#000000")) line = 2;
  else line = 3;
  /* blue */
  if (strlen(data[line]) > 63) exit(1); /* brutal! */
  strcpy(col, data[line]);
  data[line] = col;
  q = col; while (*q != '#') q++; q++;
  q[4] = 'F';
  q[5] = 'F';
  pixmaps_blue[zoom-1][type] = gdk_pixmap_create_from_xpm_d(
      gdk_get_default_root_window(), NULL, NULL, data);
  if (!pixmaps_blue[zoom-1][type]) {
    printf("error with %s\n", name);
    exit(1);
  }
  /* green */
  q[4] = '0';
  q[5] = '0';
  q[2] = 'F';
  q[3] = 'F';
  pixmaps_green[zoom-1][type] = gdk_pixmap_create_from_xpm_d(
      gdk_get_default_root_window(), NULL, NULL, data);
  if (!pixmaps_green[zoom-1][type]) {
    printf("error with %s\n", name);
    exit(1);
  }
  q[2] = '0';
  q[3] = '0';

  if (zoom == 1) {
    int width, height, _3, _1;
#if 0
    int i;
    int j;
    int cur_point;
    int nb_points = 0;
    int space = 0, white = 0, black = 0;
#endif

    if (sscanf(data[0], "%d %d %d %d", &width, &height, &_3, &_1) != 4 ||
        _3 != 3 || _1 != 1) {
err:
      fprintf(stderr, "check %s\n", name);
      exit(1);
    }
    images[type].width = width;
    images[type].height = height;

#if 0
    for (i = 1; i < 4; i++) {
      /* data[i]+4 without checking that strlen(data[i]) >= 5 is normally
       * not safe, but we are absolutely sure it works here (because we
       * produce the xpm, they don't come from nowhere).
       * If someones modifies the xpm she might have some troubles.
       */
      if (!strcmp(data[i]+4, "None")) { space = data[i][0]; continue; }
      if (!strcmp(data[i]+4, "#FFFFFF")) { white = data[i][0]; continue; }
      if (!strcmp(data[i]+4, "#000000")) { black = data[i][0]; continue; }
    }

    if (space == 0 || white == 0 || black == 0) goto err;

    for (i = 0; i < height; i++) {
      char *t = data[i+4];
      while (*t) {
        if (*t == black) nb_points++;
        else if (*t == white) /* do nothing */;
        else goto err;
        t++;
      }
    }

    images[type].points = gtk_wrapper_alloc_points(nb_points);
    if (!images[type].points) {
      fprintf(stderr, "heck, you don't have enough memory.\n");
      exit(1);
    }
    images[type].nb_points = nb_points;

    cur_point = 0;
    for (i = 0; i < height; i++) {
      char *t = data[i+4];
      j = 0;
      while (*t) {
        if (*t == black) {
          gtk_wrapper_add_point(images[type].points, cur_point, j, i);
          cur_point++;
        }
        t++;
        j++;
      }
    }
#endif
  }
#endif
}

/* barbarian exit if errors */
/* heck, I could code a shit to do this at compile time instead
 * of runtime
 * laziness...
 */
void init_image(void)
{
  process(I_BECARRE, becarre_x1_bits,
          "becarre_x1.xbm", 1,
          becarre_x1_width, becarre_x1_height);
  process(I_BEMOL, bemol_x1_bits,
          "bemol_x1.xbm", 1,
          bemol_x1_width, bemol_x1_height);
  process(I_BLACK_HEAD, black_head_x1_bits,
          "black_head_x1.xbm", 1,
          black_head_x1_width, black_head_x1_height);
  process(I_DIESE, diese_x1_bits,
          "diese_x1.xbm", 1,
          diese_x1_width, diese_x1_height);
  process(I_DOT, dot_x1_bits,
          "dot_x1.xbm", 1,
          dot_x1_width, dot_x1_height);
  process(I_DOWN_CROCHE, down_croche_x1_bits,
          "down_croche_x1.xbm", 1,
          down_croche_x1_width, down_croche_x1_height);
  process(I_DOWN_DCROCHE, down_dcroche_x1_bits,
          "down_dcroche_x1.xbm", 1,
          down_dcroche_x1_width, down_dcroche_x1_height);
  process(I_DOWN_DDCROCHE, down_ddcroche_x1_bits,
          "down_ddcroche_x1.xbm", 1,
          down_ddcroche_x1_width, down_ddcroche_x1_height);
  process(I_DOWN_DDDCROCHE, down_dddcroche_x1_bits,
          "down_dddcroche_x1.xbm", 1,
          down_dddcroche_x1_width, down_dddcroche_x1_height);
  process(I_DOWN_DDDDCROCHE, down_ddddcroche_x1_bits,
          "down_ddddcroche_x1.xbm", 1,
          down_ddddcroche_x1_width, down_ddddcroche_x1_height);
  process(I_SILENCE_BLANCHE, silence_blanche_x1_bits,
          "silence_blanche_x1.xbm", 1,
          silence_blanche_x1_width, silence_blanche_x1_height);
  process(I_SILENCE_CROCHE, silence_croche_x1_bits,
          "silence_croche_x1.xbm", 1,
          silence_croche_x1_width, silence_croche_x1_height);
  process(I_SILENCE_DCROCHE, silence_dcroche_x1_bits,
          "silence_dcroche_x1.xbm", 1,
          silence_dcroche_x1_width, silence_dcroche_x1_height);
  process(I_SILENCE_DDCROCHE, silence_ddcroche_x1_bits,
          "silence_ddcroche_x1.xbm", 1,
          silence_ddcroche_x1_width, silence_ddcroche_x1_height);
  process(I_SILENCE_DDDCROCHE, silence_dddcroche_x1_bits,
          "silence_dddcroche_x1.xbm", 1,
          silence_dddcroche_x1_width, silence_dddcroche_x1_height);
  process(I_SILENCE_DDDDCROCHE, silence_ddddcroche_x1_bits,
          "silence_ddddcroche_x1.xbm", 1,
          silence_ddddcroche_x1_width, silence_ddddcroche_x1_height);
  process(I_SILENCE_NOIRE, silence_noire_x1_bits,
          "silence_noire_x1.xbm", 1,
          silence_noire_x1_width, silence_noire_x1_height);
  process(I_SILENCE_RONDE, silence_ronde_x1_bits,
          "silence_ronde_x1.xbm", 1,
          silence_ronde_x1_width, silence_ronde_x1_height);
  process(I_UP_CROCHE, up_croche_x1_bits,
          "up_croche_x1.xbm", 1,
          up_croche_x1_width, up_croche_x1_height);
  process(I_UP_DCROCHE, up_dcroche_x1_bits,
          "up_dcroche_x1.xbm", 1,
          up_dcroche_x1_width, up_dcroche_x1_height);
  process(I_UP_DDCROCHE, up_ddcroche_x1_bits,
          "up_ddcroche_x1.xbm", 1,
          up_ddcroche_x1_width, up_ddcroche_x1_height);
  process(I_UP_DDDCROCHE, up_dddcroche_x1_bits,
          "up_dddcroche_x1.xbm", 1,
          up_dddcroche_x1_width, up_dddcroche_x1_height);
  process(I_UP_DDDDCROCHE, up_ddddcroche_x1_bits,
          "up_ddddcroche_x1.xbm", 1,
          up_ddddcroche_x1_width, up_ddddcroche_x1_height);
  process(I_WHITE_HEAD, white_head_x1_bits,
          "white_head_x1.xbm", 1,
          white_head_x1_width, white_head_x1_height);
  process(I_CLEF_C, clef_c_x1_bits,
          "clef_c.xbm", 1,
          clef_c_x1_width, clef_c_x1_height);
  process(I_CLEF_F, clef_f_x1_bits,
          "clef_f.xbm", 1,
          clef_f_x1_width, clef_f_x1_height);
  process(I_CLEF_G, clef_g_x1_bits,
          "clef_g.xbm", 1,
          clef_g_x1_width, clef_g_x1_height);
  process(I_CLEF_G_8va, clef_g_8va_x1_bits,
          "clef_g_8va.xbm", 1,
          clef_g_8va_x1_width, clef_g_8va_x1_height);
  process(I_CLEF_G_8vb, clef_g_8vb_x1_bits,
          "clef_g_8vb.xbm", 1,
          clef_g_8vb_x1_width, clef_g_8vb_x1_height);

  process(I_BECARRE, becarre_x2_bits,
          "becarre_x2.xbm", 2,
          becarre_x2_width, becarre_x2_height);
  process(I_BEMOL, bemol_x2_bits,
          "bemol_x2.xbm", 2,
          bemol_x2_width, bemol_x2_height);
  process(I_BLACK_HEAD, black_head_x2_bits,
          "black_head_x2.xbm", 2,
          black_head_x2_width, black_head_x2_height);
  process(I_DIESE, diese_x2_bits,
          "diese_x2.xbm", 2,
          diese_x2_width, diese_x2_height);
  process(I_DOT, dot_x2_bits,
          "dot_x2.xbm", 2,
          dot_x2_width, dot_x2_height);
  process(I_DOWN_CROCHE, down_croche_x2_bits,
          "down_croche_x2.xbm", 2,
          down_croche_x2_width, down_croche_x2_height);
  process(I_DOWN_DCROCHE, down_dcroche_x2_bits,
          "down_dcroche_x2.xbm", 2,
          down_dcroche_x2_width, down_dcroche_x2_height);
  process(I_DOWN_DDCROCHE, down_ddcroche_x2_bits,
          "down_ddcroche_x2.xbm", 2,
          down_ddcroche_x2_width, down_ddcroche_x2_height);
  process(I_DOWN_DDDCROCHE, down_dddcroche_x2_bits,
          "down_dddcroche_x2.xbm", 2,
          down_dddcroche_x2_width, down_dddcroche_x2_height);
  process(I_DOWN_DDDDCROCHE, down_ddddcroche_x2_bits,
          "down_ddddcroche_x2.xbm", 2,
          down_ddddcroche_x2_width, down_ddddcroche_x2_height);
  process(I_SILENCE_BLANCHE, silence_blanche_x2_bits,
          "silence_blanche_x2.xbm", 2,
          silence_blanche_x2_width, silence_blanche_x2_height);
  process(I_SILENCE_CROCHE, silence_croche_x2_bits,
          "silence_croche_x2.xbm", 2,
          silence_croche_x2_width, silence_croche_x2_height);
  process(I_SILENCE_DCROCHE, silence_dcroche_x2_bits,
          "silence_dcroche_x2.xbm", 2,
          silence_dcroche_x2_width, silence_dcroche_x2_height);
  process(I_SILENCE_DDCROCHE, silence_ddcroche_x2_bits,
          "silence_ddcroche_x2.xbm", 2,
          silence_ddcroche_x2_width, silence_ddcroche_x2_height);
  process(I_SILENCE_DDDCROCHE, silence_dddcroche_x2_bits,
          "silence_dddcroche_x2.xbm", 2,
          silence_dddcroche_x2_width, silence_dddcroche_x2_height);
  process(I_SILENCE_DDDDCROCHE, silence_ddddcroche_x2_bits,
          "silence_ddddcroche_x2.xbm", 2,
          silence_ddddcroche_x2_width, silence_ddddcroche_x2_height);
  process(I_SILENCE_NOIRE, silence_noire_x2_bits,
          "silence_noire_x2.xbm", 2,
          silence_noire_x2_width, silence_noire_x2_height);
  process(I_SILENCE_RONDE, silence_ronde_x2_bits,
          "silence_ronde_x2.xbm", 2,
          silence_ronde_x2_width, silence_ronde_x2_height);
  process(I_UP_CROCHE, up_croche_x2_bits,
          "up_croche_x2.xbm", 2,
          up_croche_x2_width, up_croche_x2_height);
  process(I_UP_DCROCHE, up_dcroche_x2_bits,
          "up_dcroche_x2.xbm", 2,
          up_dcroche_x2_width, up_dcroche_x2_height);
  process(I_UP_DDCROCHE, up_ddcroche_x2_bits,
          "up_ddcroche_x2.xbm", 2,
          up_ddcroche_x2_width, up_ddcroche_x2_height);
  process(I_UP_DDDCROCHE, up_dddcroche_x2_bits,
          "up_dddcroche_x2.xbm", 2,
          up_dddcroche_x2_width, up_dddcroche_x2_height);
  process(I_UP_DDDDCROCHE, up_ddddcroche_x2_bits,
          "up_ddddcroche_x2.xbm", 2,
          up_ddddcroche_x2_width, up_ddddcroche_x2_height);
  process(I_WHITE_HEAD, white_head_x2_bits,
          "white_head_x2.xbm", 2,
          white_head_x2_width, white_head_x2_height);
  process(I_CLEF_C, clef_c_x2_bits,
          "clef_c.xbm", 2,
          clef_c_x2_width, clef_c_x2_height);
  process(I_CLEF_F, clef_f_x2_bits,
          "clef_f.xbm", 2,
          clef_f_x2_width, clef_f_x2_height);
  process(I_CLEF_G, clef_g_x2_bits,
          "clef_g.xbm", 2,
          clef_g_x2_width, clef_g_x2_height);
  process(I_CLEF_G_8va, clef_g_8va_x2_bits,
          "clef_g_8va.xbm", 2,
          clef_g_8va_x2_width, clef_g_8va_x2_height);
  process(I_CLEF_G_8vb, clef_g_8vb_x2_bits,
          "clef_g_8vb.xbm", 2,
          clef_g_8vb_x2_width, clef_g_8vb_x2_height);

  process(I_BECARRE, becarre_x3_bits,
          "becarre_x3.xbm", 3,
          becarre_x3_width, becarre_x3_height);
  process(I_BEMOL, bemol_x3_bits,
          "bemol_x3.xbm", 3,
          bemol_x3_width, bemol_x3_height);
  process(I_BLACK_HEAD, black_head_x3_bits,
          "black_head_x3.xbm", 3,
          black_head_x3_width, black_head_x3_height);
  process(I_DIESE, diese_x3_bits,
          "diese_x3.xbm", 3,
          diese_x3_width, diese_x3_height);
  process(I_DOT, dot_x3_bits,
          "dot_x3.xbm", 3,
          dot_x3_width, dot_x3_height);
  process(I_DOWN_CROCHE, down_croche_x3_bits,
          "down_croche_x3.xbm", 3,
          down_croche_x3_width, down_croche_x3_height);
  process(I_DOWN_DCROCHE, down_dcroche_x3_bits,
          "down_dcroche_x3.xbm", 3,
          down_dcroche_x3_width, down_dcroche_x3_height);
  process(I_DOWN_DDCROCHE, down_ddcroche_x3_bits,
          "down_ddcroche_x3.xbm", 3,
          down_ddcroche_x3_width, down_ddcroche_x3_height);
  process(I_DOWN_DDDCROCHE, down_dddcroche_x3_bits,
          "down_dddcroche_x3.xbm", 3,
          down_dddcroche_x3_width, down_dddcroche_x3_height);
  process(I_DOWN_DDDDCROCHE, down_ddddcroche_x3_bits,
          "down_ddddcroche_x3.xbm", 3,
          down_ddddcroche_x3_width, down_ddddcroche_x3_height);
  process(I_SILENCE_BLANCHE, silence_blanche_x3_bits,
          "silence_blanche_x3.xbm", 3,
          silence_blanche_x3_width, silence_blanche_x3_height);
  process(I_SILENCE_CROCHE, silence_croche_x3_bits,
          "silence_croche_x3.xbm", 3,
          silence_croche_x3_width, silence_croche_x3_height);
  process(I_SILENCE_DCROCHE, silence_dcroche_x3_bits,
          "silence_dcroche_x3.xbm", 3,
          silence_dcroche_x3_width, silence_dcroche_x3_height);
  process(I_SILENCE_DDCROCHE, silence_ddcroche_x3_bits,
          "silence_ddcroche_x3.xbm", 3,
          silence_ddcroche_x3_width, silence_ddcroche_x3_height);
  process(I_SILENCE_DDDCROCHE, silence_dddcroche_x3_bits,
          "silence_dddcroche_x3.xbm", 3,
          silence_dddcroche_x3_width, silence_dddcroche_x3_height);
  process(I_SILENCE_DDDDCROCHE, silence_ddddcroche_x3_bits,
          "silence_ddddcroche_x3.xbm", 3,
          silence_ddddcroche_x3_width, silence_ddddcroche_x3_height);
  process(I_SILENCE_NOIRE, silence_noire_x3_bits,
          "silence_noire_x3.xbm", 3,
          silence_noire_x3_width, silence_noire_x3_height);
  process(I_SILENCE_RONDE, silence_ronde_x3_bits,
          "silence_ronde_x3.xbm", 3,
          silence_ronde_x3_width, silence_ronde_x3_height);
  process(I_UP_CROCHE, up_croche_x3_bits,
          "up_croche_x3.xbm", 3,
          up_croche_x3_width, up_croche_x3_height);
  process(I_UP_DCROCHE, up_dcroche_x3_bits,
          "up_dcroche_x3.xbm", 3,
          up_dcroche_x3_width, up_dcroche_x3_height);
  process(I_UP_DDCROCHE, up_ddcroche_x3_bits,
          "up_ddcroche_x3.xbm", 3,
          up_ddcroche_x3_width, up_ddcroche_x3_height);
  process(I_UP_DDDCROCHE, up_dddcroche_x3_bits,
          "up_dddcroche_x3.xbm", 3,
          up_dddcroche_x3_width, up_dddcroche_x3_height);
  process(I_UP_DDDDCROCHE, up_ddddcroche_x3_bits,
          "up_ddddcroche_x3.xbm", 3,
          up_ddddcroche_x3_width, up_ddddcroche_x3_height);
  process(I_WHITE_HEAD, white_head_x3_bits,
          "white_head_x3.xbm", 3,
          white_head_x3_width, white_head_x3_height);
  process(I_CLEF_C, clef_c_x3_bits,
          "clef_c.xbm", 3,
          clef_c_x3_width, clef_c_x3_height);
  process(I_CLEF_F, clef_f_x3_bits,
          "clef_f.xbm", 3,
          clef_f_x3_width, clef_f_x3_height);
  process(I_CLEF_G, clef_g_x3_bits,
          "clef_g.xbm", 3,
          clef_g_x3_width, clef_g_x3_height);
  process(I_CLEF_G_8va, clef_g_8va_x3_bits,
          "clef_g_8va.xbm", 3,
          clef_g_8va_x3_width, clef_g_8va_x3_height);
  process(I_CLEF_G_8vb, clef_g_8vb_x3_bits,
          "clef_g_8vb.xbm", 3,
          clef_g_8vb_x3_width, clef_g_8vb_x3_height);

  process(I_BECARRE, becarre_x4_bits,
          "becarre_x4.xbm", 4,
          becarre_x4_width, becarre_x4_height);
  process(I_BEMOL, bemol_x4_bits,
          "bemol_x4.xbm", 4,
          bemol_x4_width, bemol_x4_height);
  process(I_BLACK_HEAD, black_head_x4_bits,
          "black_head_x4.xbm", 4,
          black_head_x4_width, black_head_x4_height);
  process(I_DIESE, diese_x4_bits,
          "diese_x4.xbm", 4,
          diese_x4_width, diese_x4_height);
  process(I_DOT, dot_x4_bits,
          "dot_x4.xbm", 4,
          dot_x4_width, dot_x4_height);
  process(I_DOWN_CROCHE, down_croche_x4_bits,
          "down_croche_x4.xbm", 4,
          down_croche_x4_width, down_croche_x4_height);
  process(I_DOWN_DCROCHE, down_dcroche_x4_bits,
          "down_dcroche_x4.xbm", 4,
          down_dcroche_x4_width, down_dcroche_x4_height);
  process(I_DOWN_DDCROCHE, down_ddcroche_x4_bits,
          "down_ddcroche_x4.xbm", 4,
          down_ddcroche_x4_width, down_ddcroche_x4_height);
  process(I_DOWN_DDDCROCHE, down_dddcroche_x4_bits,
          "down_dddcroche_x4.xbm", 4,
          down_dddcroche_x4_width, down_dddcroche_x4_height);
  process(I_DOWN_DDDDCROCHE, down_ddddcroche_x4_bits,
          "down_ddddcroche_x4.xbm", 4,
          down_ddddcroche_x4_width, down_ddddcroche_x4_height);
  process(I_SILENCE_BLANCHE, silence_blanche_x4_bits,
          "silence_blanche_x4.xbm", 4,
          silence_blanche_x4_width, silence_blanche_x4_height);
  process(I_SILENCE_CROCHE, silence_croche_x4_bits,
          "silence_croche_x4.xbm", 4,
          silence_croche_x4_width, silence_croche_x4_height);
  process(I_SILENCE_DCROCHE, silence_dcroche_x4_bits,
          "silence_dcroche_x4.xbm", 4,
          silence_dcroche_x4_width, silence_dcroche_x4_height);
  process(I_SILENCE_DDCROCHE, silence_ddcroche_x4_bits,
          "silence_ddcroche_x4.xbm", 4,
          silence_ddcroche_x4_width, silence_ddcroche_x4_height);
  process(I_SILENCE_DDDCROCHE, silence_dddcroche_x4_bits,
          "silence_dddcroche_x4.xbm", 4,
          silence_dddcroche_x4_width, silence_dddcroche_x4_height);
  process(I_SILENCE_DDDDCROCHE, silence_ddddcroche_x4_bits,
          "silence_ddddcroche_x4.xbm", 4,
          silence_ddddcroche_x4_width, silence_ddddcroche_x4_height);
  process(I_SILENCE_NOIRE, silence_noire_x4_bits,
          "silence_noire_x4.xbm", 4,
          silence_noire_x4_width, silence_noire_x4_height);
  process(I_SILENCE_RONDE, silence_ronde_x4_bits,
          "silence_ronde_x4.xbm", 4,
          silence_ronde_x4_width, silence_ronde_x4_height);
  process(I_UP_CROCHE, up_croche_x4_bits,
          "up_croche_x4.xbm", 4,
          up_croche_x4_width, up_croche_x4_height);
  process(I_UP_DCROCHE, up_dcroche_x4_bits,
          "up_dcroche_x4.xbm", 4,
          up_dcroche_x4_width, up_dcroche_x4_height);
  process(I_UP_DDCROCHE, up_ddcroche_x4_bits,
          "up_ddcroche_x4.xbm", 4,
          up_ddcroche_x4_width, up_ddcroche_x4_height);
  process(I_UP_DDDCROCHE, up_dddcroche_x4_bits,
          "up_dddcroche_x4.xbm", 4,
          up_dddcroche_x4_width, up_dddcroche_x4_height);
  process(I_UP_DDDDCROCHE, up_ddddcroche_x4_bits,
          "up_ddddcroche_x4.xbm", 4,
          up_ddddcroche_x4_width, up_ddddcroche_x4_height);
  process(I_WHITE_HEAD, white_head_x4_bits,
          "white_head_x4.xbm", 4,
          white_head_x4_width, white_head_x4_height);
  process(I_CLEF_C, clef_c_x4_bits,
          "clef_c.xbm", 4,
          clef_c_x4_width, clef_c_x4_height);
  process(I_CLEF_F, clef_f_x4_bits,
          "clef_f.xbm", 4,
          clef_f_x4_width, clef_f_x4_height);
  process(I_CLEF_G, clef_g_x4_bits,
          "clef_g.xbm", 4,
          clef_g_x4_width, clef_g_x4_height);
  process(I_CLEF_G_8va, clef_g_8va_x4_bits,
          "clef_g_8va.xbm", 4,
          clef_g_8va_x4_width, clef_g_8va_x4_height);
  process(I_CLEF_G_8vb, clef_g_8vb_x4_bits,
          "clef_g_8vb.xbm", 4,
          clef_g_8vb_x4_width, clef_g_8vb_x4_height);

#if 0
  process(I_BECARRE, becarre_x2_xpm, "becarre_x2.xpm", 2);
  process(I_BEMOL, bemol_x2_xpm, "bemol_x2.xpm", 2);
  process(I_BLACK_HEAD, black_head_x2_xpm, "black_head_x2.xpm", 2);
  process(I_DIESE, diese_x2_xpm, "diese_x2.xpm", 2);
  process(I_DOT, dot_x2_xpm, "dot_x2.xpm", 2);
  process(I_DOWN_CROCHE, down_croche_x2_xpm, "down_croche_x2.xpm", 2);
  process(I_DOWN_DCROCHE, down_dcroche_x2_xpm, "down_dcroche_x2.xpm", 2);
  process(I_DOWN_DDCROCHE, down_ddcroche_x2_xpm, "down_ddcroche_x2.xpm", 2);
  process(I_DOWN_DDDCROCHE, down_dddcroche_x2_xpm, "down_dddcroche_x2.xpm", 2);
  process(I_DOWN_DDDDCROCHE, down_ddddcroche_x2_xpm,
          "down_ddddcroche_x2.xpm", 2);
  process(I_SILENCE_BLANCHE, silence_blanche_x2_xpm,
          "silence_blanche_x2.xpm", 2);
  process(I_SILENCE_CROCHE, silence_croche_x2_xpm, "silence_croche_x2.xpm", 2);
  process(I_SILENCE_DCROCHE, silence_dcroche_x2_xpm,
          "silence_dcroche_x2.xpm", 2);
  process(I_SILENCE_DDCROCHE, silence_ddcroche_x2_xpm,
          "silence_ddcroche_x2.xpm", 2);
  process(I_SILENCE_DDDCROCHE, silence_dddcroche_x2_xpm,
          "silence_dddcroche_x2.xpm", 2);
  process(I_SILENCE_DDDDCROCHE, silence_ddddcroche_x2_xpm,
          "silence_ddddcroche_x2.xpm", 2);
  process(I_SILENCE_NOIRE, silence_noire_x2_xpm, "silence_noire_x2.xpm", 2);
  process(I_SILENCE_RONDE, silence_ronde_x2_xpm, "silence_ronde_x2.xpm", 2);
  process(I_UP_CROCHE, up_croche_x2_xpm, "up_croche_x2.xpm", 2);
  process(I_UP_DCROCHE, up_dcroche_x2_xpm, "up_dcroche_x2.xpm", 2);
  process(I_UP_DDCROCHE, up_ddcroche_x2_xpm, "up_ddcroche_x2.xpm", 2);
  process(I_UP_DDDCROCHE, up_dddcroche_x2_xpm, "up_dddcroche_x2.xpm", 2);
  process(I_UP_DDDDCROCHE, up_ddddcroche_x2_xpm, "up_ddddcroche_x2.xpm", 2);
  process(I_WHITE_HEAD, white_head_x2_xpm, "white_head_x2.xpm", 2);

#if 1
  process(I_BECARRE, becarre_x3_xpm, "becarre_x3.xpm", 3);
  process(I_BEMOL, bemol_x3_xpm, "bemol_x3.xpm", 3);
  process(I_BLACK_HEAD, black_head_x3_xpm, "black_head_x3.xpm", 3);
  process(I_DIESE, diese_x3_xpm, "diese_x3.xpm", 3);
  process(I_DOT, dot_x3_xpm, "dot_x3.xpm", 3);
  process(I_DOWN_CROCHE, down_croche_x3_xpm, "down_croche_x3.xpm", 3);
  process(I_DOWN_DCROCHE, down_dcroche_x3_xpm, "down_dcroche_x3.xpm", 3);
  process(I_DOWN_DDCROCHE, down_ddcroche_x3_xpm, "down_ddcroche_x3.xpm", 3);
  process(I_DOWN_DDDCROCHE, down_dddcroche_x3_xpm, "down_dddcroche_x3.xpm", 3);
  process(I_DOWN_DDDDCROCHE, down_ddddcroche_x3_xpm,
          "down_ddddcroche_x3.xpm", 3);
  process(I_SILENCE_BLANCHE, silence_blanche_x3_xpm,
          "silence_blanche_x3.xpm", 3);
  process(I_SILENCE_CROCHE, silence_croche_x3_xpm, "silence_croche_x3.xpm", 3);
  process(I_SILENCE_DCROCHE, silence_dcroche_x3_xpm,
          "silence_dcroche_x3.xpm", 3);
  process(I_SILENCE_DDCROCHE, silence_ddcroche_x3_xpm,
          "silence_ddcroche_x3.xpm", 3);
  process(I_SILENCE_DDDCROCHE, silence_dddcroche_x3_xpm,
          "silence_dddcroche_x3.xpm", 3);
  process(I_SILENCE_DDDDCROCHE, silence_ddddcroche_x3_xpm,
          "silence_ddddcroche_x3.xpm", 3);
  process(I_SILENCE_NOIRE, silence_noire_x3_xpm, "silence_noire_x3.xpm", 3);
  process(I_SILENCE_RONDE, silence_ronde_x3_xpm, "silence_ronde_x3.xpm", 3);
  process(I_UP_CROCHE, up_croche_x3_xpm, "up_croche_x3.xpm", 3);
  process(I_UP_DCROCHE, up_dcroche_x3_xpm, "up_dcroche_x3.xpm", 3);
  process(I_UP_DDCROCHE, up_ddcroche_x3_xpm, "up_ddcroche_x3.xpm", 3);
  process(I_UP_DDDCROCHE, up_dddcroche_x3_xpm, "up_dddcroche_x3.xpm", 3);
  process(I_UP_DDDDCROCHE, up_ddddcroche_x3_xpm, "up_ddddcroche_x3.xpm", 3);
  process(I_WHITE_HEAD, white_head_x3_xpm, "white_head_x3.xpm", 3);

  process(I_BECARRE, becarre_x4_xpm, "becarre_x4.xpm", 4);
  process(I_BEMOL, bemol_x4_xpm, "bemol_x4.xpm", 4);
  process(I_BLACK_HEAD, black_head_x4_xpm, "black_head_x4.xpm", 4);
  process(I_DIESE, diese_x4_xpm, "diese_x4.xpm", 4);
  process(I_DOT, dot_x4_xpm, "dot_x4.xpm", 4);
  process(I_DOWN_CROCHE, down_croche_x4_xpm, "down_croche_x4.xpm", 4);
  process(I_DOWN_DCROCHE, down_dcroche_x4_xpm, "down_dcroche_x4.xpm", 4);
  process(I_DOWN_DDCROCHE, down_ddcroche_x4_xpm, "down_ddcroche_x4.xpm", 4);
  process(I_DOWN_DDDCROCHE, down_dddcroche_x4_xpm, "down_dddcroche_x4.xpm", 4);
  process(I_DOWN_DDDDCROCHE, down_ddddcroche_x4_xpm,
          "down_ddddcroche_x4.xpm", 4);
  process(I_SILENCE_BLANCHE, silence_blanche_x4_xpm,
          "silence_blanche_x4.xpm", 4);
  process(I_SILENCE_CROCHE, silence_croche_x4_xpm, "silence_croche_x4.xpm", 4);
  process(I_SILENCE_DCROCHE, silence_dcroche_x4_xpm,
          "silence_dcroche_x4.xpm", 4);
  process(I_SILENCE_DDCROCHE, silence_ddcroche_x4_xpm,
          "silence_ddcroche_x4.xpm", 4);
  process(I_SILENCE_DDDCROCHE, silence_dddcroche_x4_xpm,
          "silence_dddcroche_x4.xpm", 4);
  process(I_SILENCE_DDDDCROCHE, silence_ddddcroche_x4_xpm,
          "silence_ddddcroche_x4.xpm", 4);
  process(I_SILENCE_NOIRE, silence_noire_x4_xpm, "silence_noire_x4.xpm", 4);
  process(I_SILENCE_RONDE, silence_ronde_x4_xpm, "silence_ronde_x4.xpm", 4);
  process(I_UP_CROCHE, up_croche_x4_xpm, "up_croche_x4.xpm", 4);
  process(I_UP_DCROCHE, up_dcroche_x4_xpm, "up_dcroche_x4.xpm", 4);
  process(I_UP_DDCROCHE, up_ddcroche_x4_xpm, "up_ddcroche_x4.xpm", 4);
  process(I_UP_DDDCROCHE, up_dddcroche_x4_xpm, "up_dddcroche_x4.xpm", 4);
  process(I_UP_DDDDCROCHE, up_ddddcroche_x4_xpm, "up_ddddcroche_x4.xpm", 4);
  process(I_WHITE_HEAD, white_head_x4_xpm, "white_head_x4.xpm", 4);
#endif
#endif
}
