/*
 * m: a language for cgscore to describe states
 * public domain, like cgscore
 */

#include "string.h"

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

static char *buffer;
static int size;
static int maxsize;

void close_string(void)
{
  if (!maxsize) return;

  free(buffer);

  buffer = 0;
  size = maxsize = 0;
}

/* return -1 if error, a new string if ok */
string new_string(char *s)
{
  int l = strlen(s)+1;

  if (size + l > maxsize) {
    int new_size = (size + l + 255) & ~255;
    char *new;
    if (!maxsize)
      new = malloc(new_size);
    else
      new = realloc(buffer, new_size);
    if (!new) {
      fprintf(stderr, "out of memory\n");
      return -1;
    }
    maxsize = new_size;
    buffer = new;
  }

  memcpy(buffer+size, s, l);
  size += l;

  return size-l;
}

/* return -1 if error, a new string if ok */
string new_string_concat(char *s, char *s2)
{
  int l1 = strlen(s);
  int l2 = strlen(s2);
  int l = l1+l2+1;

  if (size + l > maxsize) {
    int new_size = (size + l + 255) & ~255;
    char *new;
    if (!maxsize)
      new = malloc(new_size);
    else
      new = realloc(buffer, new_size);
    if (!new) {
      fprintf(stderr, "out of memory\n");
      return -1;
    }
    maxsize = new_size;
    buffer = new;
  }

  memcpy(buffer+size, s, l1);
  memcpy(buffer+size+l1, s2, l2+1);
  size += l;

  return size-l;
}

char *get_string(string x)
{
  return buffer+x;
}
