/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

#include "gtk_wrapper.h"

#include <stdio.h>

#include "thread.h"
#include "states.h"
#include "error.h"
#include "images.h"
#include "parachute.h"

#ifdef WINDOZ
#include "winsplash_gui.h"
#endif

#ifdef INSTRUMENT_FUNCTIONS
static int elf_ok = 0;
#include "symlist.h"
#include "elf.h"
void exit(int);
#endif

#if 0
/* include to be removed */
#include "midi.h"
#endif

int main(int n, char **v)
{
  thread main_thread;

#ifdef INSTRUMENT_FUNCTIONS
  if (add_null_symbol() == -1) goto elf_fuck;
  if (get_elf_symbols("./gcomposer") == -1) {
elf_fuck:
    printf("error getting symbols\n");
    exit(1);
  }
  if (end_add_symbol() == -1) goto elf_fuck;
  elf_ok = 1;
#endif

  gtk_wrapper_init(&n, &v);

#ifdef WINDOZ
  {
    winsplash t;
    init_winsplash(&t);
    gtk_wrapper_widget_show_all(t.win);
    gtk_wrapper_main();
    gtk_wrapper_widget_destroy(t.win);
  }
#endif /* WINDOZ */

#if 0
{
  printf("yo\n");
void back(midi *m)
{
printf("callback\n");
  static int cur = 0;
  int note[] = { 60, 62, 64 };
  int note2[] = { 55, 50, 52 };
  int t[] = { 100000, 1000000, 1000000 };
  int t2[] = { 50000, 500000, 500000 };
  if (stop_finished_notes_midi(m) < 0) {
    printf("stop_finished_notes_midi error\n");
    exit(1);
  }
  if (cur != 3)
  if (play_note_midi(m, note[cur], t[cur]) < 0) {
    printf("play_note_midi error\n");
    exit(1);
  }
  if (cur != 3)
  if (play_note_midi(m, note2[cur], t2[cur]) < 0) {
    printf("play_note_midi error\n");
    exit(1);
  }
  if (set_midi_timer(m) < 0) {
    printf("set_midi_timer error\n");
    exit(1);
  }
  if (cur != 3)
  cur++;
}
  midi m;
  if (init_midi(&m) == -1) {
    printf("error init midi\n");
    exit(1);
  }
  set_midi_callback(&m, &m, back);
  set_midi_device(&m, 1);
  if (start_midi(&m, 0) < 0) {
    printf("start midi error\n");
    exit(1);
  }
  back(&m);
  printf("yo\n");
  gtk_main();
  exit(1);
}
#endif

  /* init_image must come after gtk_wrapper_init */
  init_image();

  /* parachute must be called after gtk_init, we take some stuff over */
  if (parachute() != 0) {
#if 0
    warning("Parachute could not be deployed, the program won't start.\n"
            "Try the -no-parachute command line argument to force it\n"
            "to run without the parachute.\n"
            "But beware that it will then be easier for you to lose data\n"
            "in case of program's runtime's problem.\n"
            "DO IT AT YOUR OWN RISK!", 0);
#endif
    warning("Parachute could not be deployed, the program won't start.\n", 0);
    return 0;
  }

  main_thread = new_thread();
  if (main_thread < 0) {
    fprintf(stderr, "Error:\n%s\n", get_error());
    return 1;
  }
  if (init_state_enter(main_thread) < 0) {
    fprintf(stderr, "Error:\n%s\n", get_error());
    return 1;
  }

  gtk_wrapper_main();

  /* release memory */
  thread_close();

  return 0;
}

#ifdef DEBUG_ON
#ifndef WINDOZ
/* debug stuff for my own usage, not portable at all */
/* to get pstart and pend do "readelf -e gcomposer" and get the LOAD
 * header with E flag
 */
unsigned pstart= 0x08048000;
unsigned pend = 0x08048000 + 0x696e2;
static void
__attribute__((__no_instrument_function__))
dump_calls(void *b)
{
  unsigned int *bp = b;
  int i;
  for (i=0; i < 4; i++) {
    printf("%p ", (void*)bp[1]);
    bp = (unsigned int *)bp[0];
  }
  printf(": ");
}

void *
__attribute__((__no_instrument_function__))
realloc(void *p, size_t size)
{
  extern void *__libc_realloc(void *, int);
  void *r = __libc_realloc(p, size);
  void **caller;
  __asm__ __volatile__("movl %%ebp, %0": "=g" (caller):: "memory");
  if ((unsigned)(*(caller+1)) >= pstart && (unsigned)(*(caller+1)) <= pend) {
    dump_calls(caller);
    printf("realloc(%p, %d) -> %p\n", p, size, r);
    fflush(stdout);
  }
  return r;
}

void *
__attribute__((__no_instrument_function__))
malloc(size_t size)
{
  extern void *__libc_malloc(int);
  void *r = __libc_malloc(size);
  void **caller;
  __asm__ __volatile__("movl %%ebp, %0": "=g" (caller):: "memory");
  if ((unsigned)(*(caller+1)) >= pstart && (unsigned)(*(caller+1)) <= pend) {
    dump_calls(caller);
    printf("malloc(%d) -> %p\n", size, r);
    fflush(stdout);
  }
  return r;
}

void
__attribute__((__no_instrument_function__))
free(void *p)
{
  extern void __libc_free(void *);
  void **caller;
  __asm__ __volatile__("movl %%ebp, %0": "=g" (caller):: "memory");
  if ((unsigned)(*(caller+1)) >= pstart && (unsigned)(*(caller+1)) <= pend) {
    dump_calls(caller);
    printf("free(%p)\n", p);
    fflush(stdout);
  }
  __libc_free(p);
}
#endif /* WINDOZ */
#endif /* DEBUG_ON */

#ifdef INSTRUMENT_FUNCTIONS
int in_level;
void
__attribute__((__no_instrument_function__))
__cyg_profile_func_enter (void *this_fn, void *call_site)
{
  int i = in_level++;
  int sym;
  if (!elf_ok) return;
  sym = find_symbol((unsigned long)this_fn);
  while (i--) printf(" ");
  if (sym == -1) printf("entering %p\n", this_fn);
  else printf("entering %s\n", symbol_name(sym));
}

void
__attribute__((__no_instrument_function__))
__cyg_profile_func_exit  (void *this_fn, void *call_site)
{
  int i = --in_level;
  int sym;
  if (!elf_ok) return;
  sym = find_symbol((unsigned long)this_fn);
  while (i--) printf(" ");
  if (sym == -1) printf("leaving %p\n", this_fn);
  else printf("leaving %s\n", symbol_name(sym));
}
#endif /* INSTRUMENT_FUNCTIONS */
