/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

#ifndef _MIDI_H_
#define _MIDI_H_

#ifdef ALSA
#include <asoundlib.h>
#endif

typedef struct {
  int remains; /* microseconds */ /* == -1 if channel free */
  int note; /* -1 means silence */
} midi_channel;

typedef struct {
  midi_channel channels[16];
  char **names;
  char *device; /* the device that will be used */
  int nb_devices;
  void *data;
  void (*callback)(void *);
  int fd;
  /* gtk stuff for timer */
  unsigned int timer_id;
  /* stuff for timer */
  int shot_remain;
#ifdef ALSA
  /* stuff for ALSA */
  int is_alsa;		/* 0: not ALSA, 1:ALSA */
  snd_seq_t *alsa_seq;
  int alsa_port;
#endif
} midi;

int get_midi_devices(midi *);
void free_midi_devices(midi *);
void init_midi(midi *);
int play_note_midi(midi *, int, int, int);
int stop_finished_notes_midi(midi *m);
int set_midi_timer(midi *);
int start_midi(midi *, int);
void stop_midi(midi *);
void force_midi_device(midi *, char *);
void set_midi_device(midi *, int);
void set_midi_callback(midi *, void *, void (*)(void *));

#endif /* _MIDI_H_ */
