/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

#ifndef _PLAY_H_
#define _PLAY_H_

#include "typedefs.h"

/* to synchronize visual display and audio playback */
#define NB_BUFFERS	10

/* we need to keep track of accidentals, thus we need that
 * (these value have been chosen "as is", they may change
 * in the future)
 */
#define MIN_KNOWN_NOTE	(-200)
#define MAX_KNOWN_NOTE	200
#define KNOWN_NOTES	(MAX_KNOWN_NOTE-MIN_KNOWN_NOTE+1)

typedef struct {
  float freq;
  int total;		/* nb samples */
  int current;		/* nb samples */
} play_note;

typedef struct {
  int line;
  int chord;
} buffer_position;

typedef struct {
  int line;
  int chord;
  int tempo;
  int global_mode[KNOWN_NOTES];	/* 0 = normal, -1 = bemol, 1 = diese */
  int current_mode[KNOWN_NOTES];/* 0 = normal, -1 = bemol, 1 = diese */
  int delta_clef;	/* 0 means standard G clef */
  unsigned int input_id;
  play_note *data;
  int free;
  int size;
  int maxsize;
  int remains;		/* nb samples */
  buffer_position starting_chord[NB_BUFFERS];
  int current_chord;
  int processed_chord;
  int processed_line;
} play;

int start_play(struct doc *, int, int, int);
int stop_play(struct doc *);
int in_play(struct doc *, int, int);

#endif /* _PLAY_H_ */
