/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

state options_state(doc *d)
{
  data {
    struct options_gui g;
    doc *d;
  }

  enter {
    greyall();
    data->d = d;
    (void)get_midi_devices(&d->midi);
    init_options_gui(&data->g, this->thread, d);
    gtk_wrapper_widget_show_all(data->g.win);
    disable_cursor(&data->d->cursor);
  }

  leave {
    gtk_wrapper_widget_destroy(data->g.win);
    enable_cursor(&data->d->cursor);
    greyunreg(GREY_OPTIONS_OSS);
    greyunreg(GREY_OPTIONS_MIDI);
    ungreyall();
  }

  /* oss_or_midi = 0 for oss, 1 for midi, 2 for midi alsa
   * midi_device = -1 for forced midi device
   */
  action options_done(int oss_or_midi, char *oss_device,
                      int midi_device, char *forced_midi_device,
                      int midi_instrument, int midi_adjust,
                      int midi_volume) {
    dprintf("oss_or_midi %d oss_device %s midi_device %d ",
            oss_or_midi, oss_device, midi_device);
    dprintf("forced_midi_device %s, midi_instrument %d midi_adjust %d ",
            forced_midi_device, midi_instrument, midi_adjust);
    dprintf("midi_volume %d\n", midi_volume);

    strncpy(data->d->options.audio_oss_file, oss_device, FILENAME_MAX-1);
    data->d->options.audio_oss_file[FILENAME_MAX-1] = 0;

    strncpy(data->d->options.audio_midi_file, forced_midi_device,
            FILENAME_MAX-1);
    data->d->options.audio_midi_file[FILENAME_MAX-1] = 0;

    data->d->options.ptype = oss_or_midi == 2 ? PLAY_MIDI_ALSA :
                               oss_or_midi == 1 ? PLAY_MIDI : PLAY_OSS;
    data->d->options.midi_device = midi_device;
    data->d->options.midi_instrument = midi_instrument;
    data->d->options.midi_adjust = midi_adjust;
    data->d->options.midi_volume = midi_volume;

    save_options(&data->d->options);

    RETURN;
  }

  action options_cancel {
    RETURN;
  }
}
