/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

state tutorial_clefs(tutorial_gui *g, struct gui *master_gui, int *ret)
{
  data {
    doc *d;
    int *ret;
    tutorial_gui *tut_gui;
    struct gui *master_gui;
    int step;
  }
/*
0 &
1 right
2 enter
3 &
4 #
5 u
6 u
7 u
8 u
 */

  enter {
    data->tut_gui = g;
    data->master_gui = master_gui;
    data->ret = ret;
    data->d = master_gui->doc;
    SET_TEXT_BEGIN;
#include "tut_clefs.h"
    SET_TEXT_END;
    /* set the line */
    data->d->size = 1;
    tut_lines[0].u.music.size = 0;
    tut_lines[0].u.music.data = tut_chords;
    tut_lines[1].u.music.size = 0;
    tut_lines[1].u.music.data = tut_chords+1;
    /* setup chords */
    tut_chords[0].type = CLEF;
    tut_chords[0].u.clef.type = CLEF_G;
    tut_chords[0].u.clef.position = 0;
    tut_chords[1].type = CLEF;
    tut_chords[1].u.clef.type = CLEF_G;
    tut_chords[1].u.clef.position = 0;
    /* and reset drawing stuff */
    size_reset(data->d);
    size_post_treatment(data->d);
    reset_cursor(&data->d->cursor);
    /* we are at step 0 */
    data->step = 0;
    SET_ACTION("Press '&' to insert a clef");
  }

  leave {
  }

  action key_press(int key, int control, int shift) {
    if (control) BREAK;
    switch (key) {
      case '&':
        if (data->step == 0) {
          data->step++;
          tut_lines[0].u.music.size = 1;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the right key");
        } else if (data->step == 3) {
          data->step++;
          tut_lines[1].u.music.size = 1;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press '#' to change the type of the clef");
        }
        break;
      case GDK_Right:
        if (data->step == 1) {
          data->step++;
          data->d->cursor.chord++;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press 'enter' to create a new line");
        }
        break;
      case GDK_Return:
        if (data->step == 2) {
          data->step++;
          data->d->cursor.line++;
          data->d->cursor.chord = 0;
          data->d->size++;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press '&' to insert a clef");
        }
        break;
      case '#':
        if (data->step == 4) {
          data->step++;
          tut_chords[1].u.clef.type = CLEF_F;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press 'u' to change the position of the clef");
        }
        break;
      case 'u':
        if (data->step >= 5 && data->step <= 8) {
          data->step++;
          tut_chords[1].u.clef.position++;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          switch (data->step) {
            case 6: SET_ACTION("Press the key 'u' again"); break;
            case 7: SET_ACTION("Press the key 'u' another time"); break;
            case 8: SET_ACTION("Press the key 'u' a last time"); break;
            case 9: SET_ACTION(
          "Well done! Press the button 'next' to continue the tutorial.");
              break;
          }
        }
        break;
    }
  }

  action tutorial_previous {
    (*data->ret)--;
    RETURN;
  }

  action tutorial_next {
    (*data->ret)++;
    RETURN;
  }

  action tutorial_restart {
    RETURN;
  }

  action tutorial_quit {
    *data->ret = -1;
    RETURN;
  }

  action tutorial_set_step(int step) {
    if (step != *data->ret) {
      *data->ret = step;
      RETURN;
    }
  }
}
