/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

state tutorial_init(struct gui *g)
{
  data {
    doc _d;
    doc *d;
    doc *saved;
    tutorial_gui _tut_gui;
    tutorial_gui *tut_gui;
    struct gui *g;
    int ret;
  }

  enter {
    data->saved = g->doc;
    data->d = &data->_d;
    /* let's "forget" the doc */
    memcpy(data->d, data->saved, sizeof(doc));
    data->d->size = 0;
    data->d->maxsize = 0;
    data->d->data = tut_lines;
    memset(&data->d->history, 0, sizeof(history));
    /* add an empty line */
    data->d->size = 1;
    data->d->maxsize = 1;
    tut_lines[0].u.music.size = 0;
    tut_lines[0].u.music.maxsize = 0;
    tut_lines[0].u.music.data = NULL;
    /* reset the cursor */
    data->d->cursor.type = BIG_CURSOR;
    data->d->cursor.line = 0;
    data->d->cursor.chord = 0;
    data->d->cursor.doc = data->d;
    data->d->cursor.hidden_level = data->saved->cursor.hidden_level - 1;
    /* create the tutorial gui */
    g->doc = data->d;
    data->g = g;
    data->tut_gui = &data->_tut_gui;
    init_tutorial_gui(data->tut_gui, _owner);
    SET_TEXT_BEGIN;
#include "tut_init.h"
    SET_TEXT_END;
    /* show the empty doc */
    size_reset(data->d);
    size_post_treatment(data->d);
    reset_cursor(&data->d->cursor);
    SET_ACTION("Click the 'next' button to start the tutorial.");
    gtk_wrapper_widget_show_all(data->tut_gui->win);
    tutorial_gui_activate(data->tut_gui->tut_list, 0);
    set_info(data->d, "Tutorial mode");
    greyall();
  }

  leave {
    ungreyall();
    gtk_wrapper_widget_destroy(data->tut_gui->win);
    /* we must disable the cursor but first restore the cursor */
    data->saved->cursor.hidden_level = data->d->cursor.hidden_level + 1;
    data->saved->zoom = data->d->zoom;
    disable_cursor(&data->d->cursor);
    /* restore doc */
    data->g->doc = data->saved;
    /* we need the doc to forget its height and width to force update
     * of the scrollbars
     */
    data->saved->current_width = data->saved->current_height = 0;
    size_reset(data->saved);
    size_post_treatment(data->saved);
    set_info_chord(data->saved);
  }

  action tutorial_next {
    data->ret = 0;
    tutorial_gui_activate(data->tut_gui->tut_list, 1);
    do {
      data->d->size = 1;
      tut_lines[0].u.music.data = tut_chords;
      tut_lines[0].u.music.size = 0;
      /* cursor goes to pos 0 */
      data->d->cursor.type = BIG_CURSOR;
      data->d->cursor.line = 0;
      data->d->cursor.chord = 0;
      size_reset(data->d);
      size_post_treatment(data->d);
      reset_cursor(&data->d->cursor);

      tutorial_gui_set_step(data->tut_gui->tut_list, data->ret);

      /* impossible to use CALL in 'switch' here because of bad design of the
       * 'm' language (but heck, it works as it is)
       */
      switch (data->ret) {
        case 0: goto call_tutorial_crash;
        case 1: goto call_tutorial_insert_notes;
        case 2: goto call_tutorial_insert_chord;
        case 3: goto call_tutorial_modif_note_pitch;
        case 4: goto call_tutorial_modif_note_octave;
        case 5: goto call_tutorial_modif_note_duration;
        case 6: goto call_tutorial_modif_note_alteration;
        case 7: goto call_tutorial_modif_note_nb_dots;
        case 8: goto call_tutorial_modif_note_stem_direction;
        case 9: goto call_tutorial_modif_chord;
        case 10: goto call_tutorial_fine_positioning;
        case 11: goto call_tutorial_delete;
        case 12: goto call_tutorial_silences;
        case 13: goto call_tutorial_silences_chord;
        case 14: goto call_tutorial_lines;
        case 15: goto call_tutorial_mesure_bars;
        case 16: goto call_tutorial_tonality;
        case 17: goto call_tutorial_clefs;
        case 18: goto call_tutorial_text;
        case 19: goto call_tutorial_selection;
        case 20: goto call_tutorial_undo_redo;
        case 21: goto call_tutorial_mouse;
        case 22: goto call_tutorial_playback;
        case 23: goto call_tutorial_final_word;
      }

call_tutorial_crash:
      CALL(tutorial_crash, data->tut_gui, data->g, &data->ret);
      goto after_call;
call_tutorial_insert_notes:
      CALL(tutorial_insert_notes, data->tut_gui, data->g, &data->ret);
      goto after_call;
call_tutorial_insert_chord:
      CALL(tutorial_insert_chord, data->tut_gui, data->g, &data->ret);
      goto after_call;
call_tutorial_modif_note_pitch:
      CALL(tutorial_modif_note_pitch, data->tut_gui, data->g, &data->ret);
      goto after_call;
call_tutorial_modif_note_octave:
      CALL(tutorial_modif_note_octave, data->tut_gui, data->g, &data->ret);
      goto after_call;
call_tutorial_modif_note_duration:
      CALL(tutorial_modif_note_duration, data->tut_gui, data->g, &data->ret);
      goto after_call;
call_tutorial_modif_note_alteration:
      CALL(tutorial_modif_note_alteration, data->tut_gui, data->g,
           &data->ret);
      goto after_call;
call_tutorial_modif_note_nb_dots:
      CALL(tutorial_modif_note_nb_dots, data->tut_gui, data->g, &data->ret);
      goto after_call;
call_tutorial_modif_note_stem_direction:
      CALL(tutorial_modif_note_stem_direction, data->tut_gui, data->g,
           &data->ret);
      goto after_call;
call_tutorial_fine_positioning:
      CALL(tutorial_fine_positioning, data->tut_gui, data->g, &data->ret);
      goto after_call;
call_tutorial_modif_chord:
      CALL(tutorial_modif_chord, data->tut_gui, data->g, &data->ret);
      goto after_call;
call_tutorial_delete:
      CALL(tutorial_delete, data->tut_gui, data->g, &data->ret);
      goto after_call;
call_tutorial_silences:
      CALL(tutorial_silences, data->tut_gui, data->g, &data->ret);
      goto after_call;
call_tutorial_silences_chord:
      CALL(tutorial_silences_chord, data->tut_gui, data->g, &data->ret);
      goto after_call;
call_tutorial_lines:
      CALL(tutorial_lines, data->tut_gui, data->g, &data->ret);
      goto after_call;
call_tutorial_mesure_bars:
      CALL(tutorial_mesure_bars, data->tut_gui, data->g, &data->ret);
      goto after_call;
call_tutorial_tonality:
      CALL(tutorial_tonality, data->tut_gui, data->g, &data->ret);
      goto after_call;
call_tutorial_clefs:
      CALL(tutorial_clefs, data->tut_gui, data->g, &data->ret);
      goto after_call;
call_tutorial_text:
      CALL(tutorial_text, data->tut_gui, data->g, &data->ret);
      goto after_call;
call_tutorial_selection:
      CALL(tutorial_selection, data->tut_gui, data->g, &data->ret);
      goto after_call;
call_tutorial_undo_redo:
      CALL(tutorial_undo_redo, data->tut_gui, data->g, &data->ret);
      goto after_call;
call_tutorial_mouse:
      CALL(tutorial_mouse, data->tut_gui, data->g, &data->ret);
      goto after_call;
call_tutorial_playback:
      CALL(tutorial_playback, data->tut_gui, data->g, &data->ret);
      goto after_call;
call_tutorial_final_word:
      CALL(tutorial_final_word, data->tut_gui, data->g, &data->ret);
      goto after_call;

after_call:;

    } while (data->ret >= 0);
    RETURN;
  }

  action tutorial_quit {
    RETURN;
  }
}
