/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

state tutorial_insert_notes(tutorial_gui *g, struct gui *master_gui,
                            int *ret)
{
  data {
    doc *d;
    int *ret;
    tutorial_gui *tut_gui;
    struct gui *master_gui;
    int step; /* this tutorial screen has 6 steps */
  }

  enter {
    data->tut_gui = g;
    data->master_gui = master_gui;
    data->ret = ret;
    data->d = master_gui->doc;
    SET_TEXT_BEGIN;
#include "tut_insert_notes.h"
    SET_TEXT_END;
    /* empty the line */
    tut_lines[0].u.music.maxsize = 3;
    tut_lines[0].u.music.size = 0;
    /* create 3 chords representing A B C */
    tut_chords[0].type = NOTES_CHORD;
    tut_chords[0].u.chord.data = tut_elems;
    tut_chords[0].u.chord.size = tut_chords[0].u.chord.maxsize = 1;
    tut_chords[1].type = NOTES_CHORD;
    tut_chords[1].u.chord.data = tut_elems+1;
    tut_chords[1].u.chord.size = tut_chords[1].u.chord.maxsize = 1;
    tut_chords[2].type = NOTES_CHORD;
    tut_chords[2].u.chord.data = tut_elems+2;
    tut_chords[2].u.chord.size = tut_chords[2].u.chord.maxsize = 1;
    tut_elems[0].type = NOTE;
    tut_elems[0].u.note.pitch = 1;
    tut_elems[0].u.note.alteration = NORMAL;
    tut_elems[0].u.note.duration = NOIRE;
    tut_elems[0].u.note.nb_dots = 0;
    tut_elems[1].type = NOTE;
    tut_elems[1].u.note.pitch = 2;
    tut_elems[1].u.note.alteration = NORMAL;
    tut_elems[1].u.note.duration = NOIRE;
    tut_elems[1].u.note.nb_dots = 0;
    tut_elems[2].type = NOTE;
    tut_elems[2].u.note.pitch = 3;
    tut_elems[2].u.note.alteration = NORMAL;
    tut_elems[2].u.note.duration = NOIRE;
    tut_elems[2].u.note.nb_dots = 0;
    /* and reset drawing stuff */
    size_reset(data->d);
    size_post_treatment(data->d);
    reset_cursor(&data->d->cursor);
    /* we are at step 0 */
    data->step = 0;
    SET_ACTION("Press the key 'a'");
  }

  leave {
  }

  action key_press(int key, int control, int shift) {
    if (control) BREAK;
    switch (key) {
      case 'a':
      case 'A':
        if (data->step == 0) {
          data->step = 1;
          tut_lines[0].u.music.size = 1;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the right arrow");
        }
        break;
      case 'b':
      case 'B':
        if (data->step == 2) {
          data->step = 3;
          tut_lines[0].u.music.size = 2;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the right arrow");
        }
        break;
      case 'c':
      case 'C':
        if (data->step == 4) {
          data->step = 5;
          tut_lines[0].u.music.size = 3;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION(
  "Well done! Press the button 'next' to continue the tutorial.");
        }
        break;
      case GDK_Right:
        if (shift) break;
        if (data->step == 1 || data->step == 3) {
          data->step++;
          //clear_cursor(&data->d->cursor);
          data->d->cursor.chord++;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          switch (data->step) {
            case 2: SET_ACTION("Press the key 'b'"); break;
            case 4: SET_ACTION("Press the key 'c'"); break;
          }
        }
        break;
    }
  }

  action tutorial_previous {
    (*data->ret)--;
    RETURN;
  }

  action tutorial_next {
    (*data->ret)++;
    RETURN;
  }

  action tutorial_restart {
    RETURN;
  }

  action tutorial_quit {
    *data->ret = -1;
    RETURN;
  }

  action tutorial_set_step(int step) {
    if (step != *data->ret) {
      *data->ret = step;
      RETURN;
    }
  }
}
