/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

state tutorial_lines(tutorial_gui *g, struct gui *master_gui, int *ret)
{
  data {
    doc *d;
    int *ret;
    tutorial_gui *tut_gui;
    struct gui *master_gui;
    int step;
  }
/*
0 a
1 right
2 enter
3 b
4 up
5 enter
6 up
7 c
8 right
9 del
10 down
11 backspace
 */

  enter {
    data->tut_gui = g;
    data->master_gui = master_gui;
    data->ret = ret;
    data->d = master_gui->doc;
    SET_TEXT_BEGIN;
#include "tut_lines.h"
    SET_TEXT_END;
    /* set the line */
    data->d->size = 1;
    tut_lines[0].u.music.size = 0;
    /* create three notes */
    tut_chords[0].type = NOTES_CHORD;
    tut_chords[0].u.chord.data = tut_elems;
    tut_chords[0].u.chord.size = 1;
    tut_chords[1].type = NOTES_CHORD;
    tut_chords[1].u.chord.data = tut_elems+1;
    tut_chords[1].u.chord.size = 1;
    tut_chords[2].type = NOTES_CHORD;
    tut_chords[2].u.chord.data = tut_elems+2;
    tut_chords[2].u.chord.size = 1;
    tut_elems[0].type = NOTE;
    tut_elems[0].u.note.pitch = 1;
    tut_elems[0].u.note.alteration = NORMAL;
    tut_elems[0].u.note.duration = NOIRE;
    tut_elems[0].u.note.nb_dots = 0;
    tut_elems[1].type = NOTE;
    tut_elems[1].u.note.pitch = 2;
    tut_elems[1].u.note.alteration = NORMAL;
    tut_elems[1].u.note.duration = NOIRE;
    tut_elems[1].u.note.nb_dots = 0;
    tut_elems[2].type = NOTE;
    tut_elems[2].u.note.pitch = 3;
    tut_elems[2].u.note.alteration = NORMAL;
    tut_elems[2].u.note.duration = NOIRE;
    tut_elems[2].u.note.nb_dots = 0;
    /* and reset drawing stuff */
    size_reset(data->d);
    size_post_treatment(data->d);
    reset_cursor(&data->d->cursor);
    /* we are at step 0 */
    data->step = 0;
    SET_ACTION("Press the key 'a' (to insert an A)");
  }

  leave {
  }

  action key_press(int key, int control, int shift) {
    if (control) BREAK;
    switch (key) {
      case 'a':
      case 'A':
        if (data->step == 0) {
          data->step++;
          tut_lines[0].u.music.size = 1;
          tut_lines[0].u.music.data = tut_chords;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the right key");
        }
        break;
      case GDK_Right:
        if (data->step == 1 || data->step == 8) {
          data->step++;
          data->d->cursor.chord++;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          switch (data->step) {
            case 2: SET_ACTION("Press the key 'enter' to create a new line");
              break;
            case 9:
              SET_ACTION(
    "Press the key 'del' to merge the current line and the next one");
              break;
          }
        }
        break;
      case GDK_Return:
        if (data->step == 2) {
          data->step++;
          data->d->size++;
          data->d->cursor.line = 1;
          data->d->cursor.chord = 0;
          tut_lines[1].u.music.size = 0;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the key 'b' (to insert a B)");
        } else if (data->step == 5) {
          data->step++;
          data->d->size++;
          data->d->cursor.line = 1;
          data->d->cursor.chord = 0;
          tut_lines[2] = tut_lines[1];
          tut_lines[1] = tut_lines[2];
          tut_lines[0].u.music.size = 0;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the up key");
        }
        break;
      case 'b':
      case 'B':
        if (data->step == 3) {
          data->step++;
          tut_lines[1].u.music.size = 1;
          tut_lines[1].u.music.data = tut_chords+1;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the up key");
        }
        break;
      case GDK_Up:
        if (data->step == 4 || data->step == 6) {
          data->step++;
          data->d->cursor.line = 0;
          data->d->cursor.chord = 0;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          if (data->step == 5)
            SET_ACTION("Press the key 'enter'");
          else
            SET_ACTION("Press the key 'c' (to insert a C)");
        }
        break;
      case 'c':
      case 'C':
        if (data->step == 7) {
          data->step++;
          tut_lines[0].u.music.size = 1;
          tut_lines[0].u.music.data = tut_chords+2;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the right key");
        }
        break;
      case GDK_Delete:
        if (data->step == 9) {
          data->step++;
          data->d->size--;
          tut_lines[0].u.music.size = 2;
          tut_chords[3] = tut_chords[0];
          tut_lines[1] = tut_lines[2];
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the down key");
        }
        break;
      case GDK_Down:
        if (data->step == 10) {
          data->step++;
          data->d->cursor.line++;
          data->d->cursor.chord = 0;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION(
 "Press the key 'backspace' to merge the current line with the previous one");
        }
        break;
      case GDK_BackSpace:
        if (data->step == 11) {
          data->step++;
          data->d->size--;
          data->d->cursor.line = 0;
          data->d->cursor.chord = 2;
          tut_lines[0].u.music.size = 3;
          tut_chords[4] = tut_chords[1];
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION(
            "Well done! Press the button 'next' to continue the tutorial.");
        }
        break;
    }
  }

  action tutorial_previous {
    (*data->ret)--;
    RETURN;
  }

  action tutorial_next {
    (*data->ret)++;
    RETURN;
  }

  action tutorial_restart {
    RETURN;
  }

  action tutorial_quit {
    *data->ret = -1;
    RETURN;
  }

  action tutorial_set_step(int step) {
    if (step != *data->ret) {
      *data->ret = step;
      RETURN;
    }
  }
}
