/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

state tutorial_modif_note_stem_direction(tutorial_gui *g,
                                         struct gui *master_gui,
                                         int *ret)
{
  data {
    doc *d;
    int *ret;
    tutorial_gui *tut_gui;
    struct gui *master_gui;
    int step; /* 2 steps */
/*
steps:
0 j
1 J
 */
  }

  enter {
    data->tut_gui = g;
    data->master_gui = master_gui;
    data->ret = ret;
    data->d = master_gui->doc;
    SET_TEXT_BEGIN;
#include "tut_modif_note_stem_direction.h"
    SET_TEXT_END;
    /* set the line */
    data->d->size = 1;
    data->d->maxsize = 1;
    /* put one note on the line */
    tut_lines[0].u.music.size = 1;
    tut_lines[0].u.music.maxsize = 1;
    /* create one note */
    tut_chords[0].type = NOTES_CHORD;
    tut_chords[0].u.chord.data = tut_elems;
    tut_chords[0].u.chord.size = 1;
    tut_chords[0].u.chord.maxsize = 1;
    tut_elems[0].type = NOTE;
    tut_elems[0].u.note.pitch = 3;
    tut_elems[0].u.note.alteration = BECARRE;
    tut_elems[0].u.note.duration = DDCROCHE;
    tut_elems[0].u.note.nb_dots = 1;
    /* and reset drawing stuff */
    size_reset(data->d);
    size_post_treatment(data->d);
    reset_cursor(&data->d->cursor);
    /* we are at step 0 */
    data->step = 0;
    SET_ACTION("Press 'j' to set the stem down");
  }

  leave {
  }

  action key_press(int key, int control, int shift) {
    if (control) BREAK;
    switch (key) {
      case 'j':
        if (data->step == 0) {
          data->step++;
          clear_cursor(&data->d->cursor);
          tut_elems[0].u.note.stem_down = 1;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press 'J' to set the stem up");
          break;
        }
      case 'J':
        if (data->step == 1) {
          data->step++;
          clear_cursor(&data->d->cursor);
          tut_elems[0].u.note.stem_down = 0;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION(
  "Well done! Press the button 'next' to continue the tutorial.");
          break;
        }
    }
  }

  action tutorial_previous {
    (*data->ret)--;
    RETURN;
  }

  action tutorial_next {
    (*data->ret)++;
    RETURN;
  }

  action tutorial_restart {
    RETURN;
  }

  action tutorial_quit {
    *data->ret = -1;
    RETURN;
  }

  action tutorial_set_step(int step) {
    if (step != *data->ret) {
      *data->ret = step;
      RETURN;
    }
  }
}
