/* gcomposer: a little tool to write music.
 * http://sed.free.fr/gcomposer
 * Released in the public domain (freedom has no license).
 */

state tutorial_silences_chord(tutorial_gui *g, struct gui *master_gui,
                              int *ret)
{
  data {
    doc *d;
    int *ret;
    tutorial_gui *tut_gui;
    struct gui *master_gui;
    int step;
  }
/* steps
0 i
1 s
2 U
3 U
4 U
5 t
6 ESC
 */

  enter {
    data->tut_gui = g;
    data->master_gui = master_gui;
    data->ret = ret;
    data->d = master_gui->doc;
    SET_TEXT_BEGIN;
#include "tut_silences_chord.h"
    SET_TEXT_END;
    /* set the line */
    tut_lines[0].u.music.size = 1;
    tut_chords[0].type = NOTES_CHORD;
    tut_chords[0].u.chord.data = tut_elems;
    tut_chords[0].u.chord.size = 3;
    tut_elems[0].type = NOTE;
    tut_elems[0].u.note.pitch = 1;
    tut_elems[0].u.note.alteration = NORMAL;
    tut_elems[0].u.note.duration = NOIRE;
    tut_elems[0].u.note.nb_dots = 0;
    tut_elems[1].type = NOTE;
    tut_elems[1].u.note.pitch = 3;
    tut_elems[1].u.note.alteration = NORMAL;
    tut_elems[1].u.note.duration = NOIRE;
    tut_elems[1].u.note.nb_dots = 0;
    tut_elems[2].type = NOTE;
    tut_elems[2].u.note.pitch = 5;
    tut_elems[2].u.note.alteration = NORMAL;
    tut_elems[2].u.note.duration = NOIRE;
    tut_elems[2].u.note.nb_dots = 0;
    /* and reset drawing stuff */
    size_reset(data->d);
    size_post_treatment(data->d);
    reset_cursor(&data->d->cursor);
    /* we are at step 0 */
    data->step = 0;
    SET_ACTION("Press the key 'i' to enter i mode");
  }

  leave {
  }

  action key_press(int key, int control, int shift) {
    if (control) BREAK;
    switch (key) {
      case 'i':
        if (data->step == 0) {
          data->step++;
          clear_cursor(&data->d->cursor);
          data->d->cursor.type = SMALL_CURSOR;
          data->d->cursor.note = 0;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION(
              "Press the key 's' to insert a rest");
        }
        break;
      case 's':
        if (data->step == 1) {
          data->step++;
          clear_cursor(&data->d->cursor);
          tut_chords[0].u.chord.size++;
          tut_elems[3] = tut_elems[2];
          tut_elems[2] = tut_elems[1];
          tut_elems[1] = tut_elems[0];
          tut_elems[0].type = SILENCE;
          tut_elems[0].u.silence.position = 0;
          tut_elems[0].u.silence.duration = NOIRE;
          tut_elems[0].u.silence.nb_dots = 0;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION(
              "Press the key 'U' (to change the position of the rest)");
        }
        break;
      case 'U':
        if (data->step == 2 || data->step == 3 || data->step == 4) {
          data->step++;
          clear_cursor(&data->d->cursor);
          tut_elems[0].u.silence.position--;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          switch (data->step) {
            case 3: SET_ACTION("Press the key 'U' again"); break;
            case 4: SET_ACTION("Press the key 'U' one more time"); break;
            case 5: SET_ACTION(
              "Press the key 't' (to change the duration of the rest)");
              break;
          }
        }
        break;
      case 't':
        if (data->step == 5) {
          data->step++;
          clear_cursor(&data->d->cursor);
          tut_elems[0].u.silence.duration++;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION("Press the key 'Esc' (to leave the i mode)");
        }
        break;
      case GDK_Escape:
        if (data->step == 6) {
          data->step++;
          clear_cursor(&data->d->cursor);
          data->d->cursor.type = BIG_CURSOR;
          size_reset(data->d);
          size_post_treatment(data->d);
          reset_cursor(&data->d->cursor);
          SET_ACTION(
            "Well done! Press the button 'next' to continue the tutorial.");
        }
        break;
    }
  }

  action tutorial_previous {
    (*data->ret)--;
    RETURN;
  }

  action tutorial_next {
    (*data->ret)++;
    RETURN;
  }

  action tutorial_restart {
    RETURN;
  }

  action tutorial_quit {
    *data->ret = -1;
    RETURN;
  }

  action tutorial_set_step(int step) {
    if (step != *data->ret) {
      *data->ret = step;
      RETURN;
    }
  }
}
